-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql


module UsersApi.InputObject exposing (..)

import CustomScalarCodecs
import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.Internal.Encode as Encode exposing (Value)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode
import UsersApi.Interface
import UsersApi.Object
import UsersApi.Scalar
import UsersApi.Union


buildNewUser : NewUserRequiredFields -> NewUser
buildNewUser required =
    { firstName = required.firstName, lastName = required.lastName, bannerId = required.bannerId, email = required.email }


type alias NewUserRequiredFields =
    { firstName : String
    , lastName : String
    , bannerId : Int
    , email : String
    }


{-| Type for the NewUser input object.
-}
type alias NewUser =
    { firstName : String
    , lastName : String
    , bannerId : Int
    , email : String
    }


{-| Encode a NewUser into a value that can be used as an argument.
-}
encodeNewUser : NewUser -> Value
encodeNewUser input =
    Encode.maybeObject
        [ ( "firstName", Encode.string input.firstName |> Just ), ( "lastName", Encode.string input.lastName |> Just ), ( "bannerId", Encode.int input.bannerId |> Just ), ( "email", Encode.string input.email |> Just ) ]


buildPartialUser : (PartialUserOptionalFields -> PartialUserOptionalFields) -> PartialUser
buildPartialUser fillOptionals =
    let
        optionals =
            fillOptionals
                { firstName = Absent, lastName = Absent, bannerId = Absent, email = Absent }
    in
    { firstName = optionals.firstName, lastName = optionals.lastName, bannerId = optionals.bannerId, email = optionals.email }


type alias PartialUserOptionalFields =
    { firstName : OptionalArgument String
    , lastName : OptionalArgument String
    , bannerId : OptionalArgument Int
    , email : OptionalArgument String
    }


{-| Type for the PartialUser input object.
-}
type alias PartialUser =
    { firstName : OptionalArgument String
    , lastName : OptionalArgument String
    , bannerId : OptionalArgument Int
    , email : OptionalArgument String
    }


{-| Encode a PartialUser into a value that can be used as an argument.
-}
encodePartialUser : PartialUser -> Value
encodePartialUser input =
    Encode.maybeObject
        [ ( "firstName", Encode.string |> Encode.optional input.firstName ), ( "lastName", Encode.string |> Encode.optional input.lastName ), ( "bannerId", Encode.int |> Encode.optional input.bannerId ), ( "email", Encode.string |> Encode.optional input.email ) ]
